// Path.h: interface for the CPath class.
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_PATH_H__B0F00FA0_6587_11D4_B4E9_E02350C10000__INCLUDED_)
#define AFX_PATH_H__B0F00FA0_6587_11D4_B4E9_E02350C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h>
#include "filterTables.h"
#include "GaussFIR.h"

class CPath  
{
public:
	void CalcPath( _complex* pIn, _complex* pOut);
	void InitPath( double Spread, double Offset, INT blocksize,INT numpaths, BOOL active);
	CPath();
	virtual ~CPath();

private:
	INT m_IIRLength;
	_complex MakeGaussianDelaySample();
	INT m_NoiseSampRate;
	BOOL m_PathActive;
	INT m_inc;
	INT m_BlockSize;
	INT m_Indx;
	double m_Offset;
	double m_Spread;
	double m_LPGain;
	double m_Timeinc;
	_complex m_pQue0[INTP_QUE_SIZE];
	_complex m_pQue1[INTP_QUE_SIZE];
	_complex m_pQue2[INTP_QUE_SIZE];
	_complex m_pQue3[INTP_QUE_SIZE];
	INT m_FirState0;
	INT m_FirState1;
	INT m_FirState2;
	INT m_FirState3;
	CGaussFIR* m_pLPFIR;

};

#endif // !defined(AFX_PATH_H__B0F00FA0_6587_11D4_B4E9_E02350C10000__INCLUDED_)
