// PathSimDoc.h : interface of the CPathSimDoc class
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_PATHSIMDOC_H__22C08F8A_5014_11D4_B4E9_802650C10000__INCLUDED_)
#define AFX_PATHSIMDOC_H__22C08F8A_5014_11D4_B4E9_802650C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define USE_SOUNDCARD 0
#define USE_WAVEFILE 1

#define SIMSTATE_OFF 0
#define SIMSTATE_ON 1
#define SIMSTATE_WAIT 2

class CPathSimDoc : public CDocument
{
protected: // create from serialization only
	CPathSimDoc();
	DECLARE_DYNCREATE(CPathSimDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPathSimDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPathSimDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	INT GetInputFileLength();
	UINT m_SamplesWritten;
	INT m_InFileLength;
	BOOL m_WaveToWave;
	double m_SigRMS;
	double m_NoiseRMS;
	BOOL m_DirectPathActive;
	INT GetDiskInfo(CString& sFree, CString& sNeeded);
	BOOL m_SaveAWGN;
	BOOL m_SaveRunTime;
	BOOL m_SaveInputs;
	BOOL m_SaveOutputs;
	BOOL m_AppendTitle;
	BOOL m_UseDelayStart;
	BOOL m_AWGNOn;
	BOOL m_Path0On;
	BOOL m_Path1On;
	BOOL m_Path2On;
	INT m_DelayStartHour;
	INT m_DelayStartMin;
	CString m_SimTitle;
	UINT GetDiskSpace();
	CTime m_StartTime;
	CString m_InFileInfo;
	CString m_InFilePath;
	CString m_OutFilePath;
	CString m_OutFileName;
	CString m_InFileName;
	INT m_OutputSelect;
	INT m_InputSelect;
	INT m_SimState;
	UINT m_TimeLimit;
	double	m_Offset0;
	double	m_Offset1;
	double	m_Offset2;
	double	m_Spread0;
	double	m_Spread1;
	double	m_Spread2;
	double	m_Delay1;
	double	m_Delay2;
	INT	m_SNRSetValue;

protected:
	BOOL WriteToRegistry();
	BOOL ReadFromRegistry();


// Generated message map functions
protected:
	//{{AFX_MSG(CPathSimDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	INT m_SetupBools;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PATHSIMDOC_H__22C08F8A_5014_11D4_B4E9_802650C10000__INCLUDED_)
