///////////////////////////////////////////////////////
// Perform.h : Global interface for the performance functions
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@mindspring.com>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////////////
//

#if !defined(_INCLUDE_PERFORMXXX_H_)
#define _INCLUDE_PERFORMXXX_H_
#include <math.h>

/////////////////////////////////////////////////////////////////////////////
extern void InitPerformance();
extern void StartPerformance();
extern void StopPerformance();
extern void ReadPerformance();
extern void SamplePerformance();



extern double testfreq;
extern double gDebug1;
extern double gDebug2;
extern INT iDebug3;


extern void CalcCpxSweepRMS(_complex sample, INT samplength);
extern void CalcSweepRMS(double sample, INT samplength);
extern void CalcCpxSweepPhz(_complex sample, INT samplength);

extern void SweepGen( double* output, double samprate, 
							double start, double stop, double step);
extern void SweepGenCpx( _complex* output, double samprate, 
							double start, double stop, double step);
extern void HistogramSamp(  double sample, double min, double max, INT numsamps );

extern void EndTest(void);
extern double CalcCpxRMS(_complex sample, INT numsamps);
extern double CalcRunAveRMS(double* buf, INT bufsize);
extern double CalcCpxRunAveRMS(_complex* buf, INT bufsize);
extern double CalcTotalRMS(double* buf, INT numsamps);

#endif //#if !defined(_INCLUDE_PERFORMXXX_H_)